CURLOPT_PROGRESSDATA(3)

NAME
CURLOPT_PROGRESSDATA - pointer passed to the progress callback

SYNOPSIS
#include <curl/curl.h>
CURLcode curl_easy_setopt(CURL *handle, CURLOPT_PROGRESSDATA, void *pointer);

DESCRIPTION
Pass a pointer that is untouched by libcurl and passed as the first argument in the progress callback set with CURLOPT_PROGRESSFUNCTION(3).

DEFAULT
NULL

PROTOCOLS
This functionality affects all supported protocols

EXAMPLE
struct progress {
  char *private;
  size_t size;
};
static size_t progress_callback(void *clientp,
                                double dltotal,
                                double dlnow,
                                double ultotal,
                                double ulnow)
{
  struct progress *memory = clientp;
  printf("private: %p\n", memory->private);
  /* use the values */
  return 0; /* all is good */
}
int main(void)
{
  CURL *curl = curl_easy_init();
  if(curl) {
    struct progress data;
    /* pass struct to callback  */
    curl_easy_setopt(curl, CURLOPT_PROGRESSDATA, &data);
    curl_easy_setopt(curl, CURLOPT_PROGRESSFUNCTION, progress_callback);
    curl_easy_perform(curl);
  }
}

AVAILABILITY
Added in curl 7.1

RETURN VALUE
Returns CURLE_OK

SEE ALSO
CURLOPT_PROGRESSFUNCTION(3), CURLOPT_XFERINFOFUNCTION(3)